package com.ydl.ydlcommon.utils.log

import com.aliyun.sls.android.producer.Log
import com.ydl.ydlcommon.base.BaseApp.Companion.getApp
import com.ydl.ydlcommon.data.PlatformDataManager.getRam
import com.ydl.ydlcommon.modular.ModularServiceManager.getPlatformUserService
import com.ydl.ydlnet.utils.log.AliYunLogHelper
import com.yidianling.common.tools.RxAppTool
import com.yidianling.common.tools.RxDeviceTool

/**
 * @author liupeng
 *
 * 阿里云埋点，携带基本参数，方便后续排查问题定位
 * */
class AliYunRichLogsHelper {
    companion object {
        fun getInstance(): AliYunRichLogsHelper {
            return Holder.INSTANCE
        }
    }

    private object Holder {
        val INSTANCE = AliYunRichLogsHelper()
    }

    /**
     *
     * @param key AliYunLogConfig 接口、登录、声网、WebView、支付、其他
     * @param value 具体的状态值
     * */
    fun sendRichLog(key: String, value: String) {
        val log = Log()
        val userInfo = getPlatformUserService()!!.getUser()

        log.putContent(key, value)
        log.putContent("ffrom", getRam().getChannelName())
        log.putContent("isFromApp", "1")
        log.putContent("osBuild", RxDeviceTool.getBuildBrandModel())
        log.putContent(RxDeviceTool.getSDKVersionName(), RxAppTool.getAppVersionName(getApp()))
        log.putContent("version", RxAppTool.getAppVersionName(getApp()))
        if (null != userInfo) {
            log.putContent("uid", userInfo.userId)
            log.putContent("accessToken", userInfo.token)
        }
        AliYunLogHelper.getInstance().sendLog(log)
    }
}